--post hooks + custom function to make team AI equip their primaries if a teammate is tased, downed, cuffed, etc

Hooks:PostHook(GroupAIStateBase, "on_criminal_disabled", "gun_palz_oncriminaldisabled", function(self, unit, ...)
	if not Network:is_server() then
		return
	end

	self:chk_team_ai_should_switch_to_primaries(unit)
end)

Hooks:PostHook(GroupAIStateBase, "on_criminal_neutralized", "gun_palz_oncriminalneutralized", function(self, unit)
	if not Network:is_server() then
		return
	end

	self:chk_team_ai_should_switch_to_primaries(unit)
end)

--this is for the affected criminal themselves
Hooks:PostHook(GroupAIStateBase, "on_criminal_recovered", "gun_palz_oncriminalrecovered", function(self, criminal_unit)
	if not Network:is_server() or not self:all_AI_criminals()[criminal_unit:key()] then
		return
	end

	local inv_ext = criminal_unit:inventory()

	if inv_ext:is_selection_available(2) then
		inv_ext:equip_selection(2, true)
	elseif inv_ext:is_selection_available(1) then
		inv_ext:equip_selection(1, true)
	end
end)

Hooks:PostHook(GroupAIStateBase, "set_assault_mode", "gun_palz_setassaultmode", function(self, ...)
	if self._assault_mode then
		self:chk_team_ai_should_switch_to_primaries()
	else
		self:chk_team_ai_should_switch_to_secondaries()
	end
end)

function GroupAIStateBase:chk_team_ai_should_switch_to_primaries(afflicted_unit)
	local all_criminals = self:all_AI_criminals()
	local afflicted_u_key = afflicted_unit and afflicted_unit:key()

	for u_key, u_data in pairs(all_criminals) do
		if not u_data.status then
			if not afflicted_u_key or afflicted_u_key ~= u_key then
				local unit = u_data.unit
				local inv_ext = unit:inventory()

				if inv_ext:equipped_selection() ~= 2 then
					local function f()
						if not alive(unit) or u_data.status or not all_criminals[u_key] then
							return
						end

						inv_ext = unit:inventory()

						if not inv_ext then
							return
						end

						if inv_ext:equipped_selection() ~= 2 then
							if inv_ext:is_selection_available(2) then
								inv_ext:equip_selection(2, true)
							elseif inv_ext:is_selection_available(1) then
								inv_ext:equip_selection(1, true)
							end
						end
					end

					managers.enemy:add_delayed_clbk("gun_palz_switch_to_primary" .. tostring(u_key), f, TimerManager:game():time() + math.random(6) - 1)
				end
			end
		end
	end
end

function GroupAIStateBase:chk_team_ai_should_switch_to_secondaries()
	local all_criminals = self:all_AI_criminals()

	for u_key, u_data in pairs(all_criminals) do
		if not u_data.status then
			local unit = u_data.unit
			local inv_ext = unit:inventory()

			if inv_ext:equipped_selection() ~= 1 then
				local function f()
					if not alive(unit) or u_data.status or not all_criminals[u_key] then
						return
					end

					inv_ext = unit:inventory()

					if not inv_ext then
						return
					end

					if inv_ext:equipped_selection() ~= 1 then
						if inv_ext:is_selection_available(1) then
							inv_ext:equip_selection(1, true)
						elseif inv_ext:is_selection_available(2) then
							inv_ext:equip_selection(2, true)
						end
					end
				end

				managers.enemy:add_delayed_clbk("gun_palz_switch_to_secondary" .. tostring(u_key), f, TimerManager:game():time() + 1)
			end
		end
	end
end
