--load custom melee weapon units if needed
Hooks:PostHook(HuskTeamAIBase, "post_init", "gun_palz_huskteamaipostinit", function(self, ...)
	local set_melee = self._char_tweak.melee_weapon

	if not set_melee then
		return
	end

	local melee_weapon_data = managers.blackmarket:get_melee_weapon_data(set_melee)
	local third_unit = melee_weapon_data and melee_weapon_data.third_unit

	if not third_unit then
		return
	end

	local name = Idstring(third_unit)
	self._melee_unit_name = name

	managers.dyn_resource:load(Idstring("unit"), name, DynamicResourceManager.DYN_RESOURCES_PACKAGE, false)
end)

function HuskTeamAIBase:melee_weapon()
	return TeamAIBase.melee_weapon(self)
end

--if a melee weapon unit had to be loaded, make sure to unload it when the cop despawns
--with both loading and unloading, calling these multiple times despite the weapon already being loaded once is fine (as long as you load and unload consistently)
--the system works using a counter, and when it goes back down to 0, the asset is finally unloaded for real
Hooks:PostHook(HuskTeamAIBase, "pre_destroy", "gun_palz_huskteamipredestroy", function(self, ...)
	local loaded_melee_unit_name = self._melee_unit_name

	if loaded_melee_unit_name then
		self._melee_unit_name = nil

		managers.dyn_resource:unload(Idstring("unit"), loaded_melee_unit_name, DynamicResourceManager.DYN_RESOURCES_PACKAGE, false)
	end
end)
